QGIS Application - Bug report #11498
spatialite layer added via browser lose first field
2014-10-25 08:25 AM - Luca Lanteri

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/OGR

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 19768
Description

When loading a spatialite layer using browser (browsing the file, not using the connection) the first field of the table (may be only if it's a
pkey) is not shown

Related issues:
Related to QGIS Application - Bug report # 6226: Primary key field hidden on ... Closed 2012-08-20

History

#1 - 2014-10-25 08:32 AM - Giovanni Manghi
- Status changed from Open to Feedback

cannot replicate in qgis master, can you attach sample data?

#2 - 2014-10-25 08:36 AM - Luca Lanteri

You have to add the SL layer using the browser view, not the SL connection. Just tested now on 2.4.

#3 - 2014-10-25 08:47 AM - Giovanni Manghi

mescal72 - wrote:

You have to add the SL layer using the browser view

| did

#4 - 2014-10-25 08:48 AM - Salvatore Larosa

| cannot replicate neither on 2.4 nor on master.

Tested with a table with primary key and polygon geometry.

a small sample data to replicate the issue is necessary.

#5 - 2014-10-25 09:16 AM - Luca Lanteri
- File test.sqlite added
You're right: | try with a brand new DB and it works, but if | use some other DB the problem persists.
| can't understand if it's a SL version problem. All my databases may be: SpatiaLite version 4.1.1
and SQLite version 3.8.2. I'll try to investigate deeper.

| try to attach an example db.

#6 - 2014-10-25 09:28 AM - Salvatore Larosa

neither with the attached DB, | see with both browser and add button:
gid,arpa,id,_old,attivita

| am trying with SL 4.0.0 and SQLite 3.7.13

#7 - 2014-10-25 09:38 AM - Luca Lanteri

mmm...

| also view all field if | load it via SL connection (using the "feather" button or browser with SL connection), but If | browse the file system using browser |
lose the "gid" field.

| tested it on linux and win7 and QGIS 2.0 and 2.4.
I really not understand how to replicate it but I'm sure it isn't a local problem

#8 - 2014-10-26 02:51 AM - Giovanni Manghi
- Status changed from Feedback to Open
- Affected QGIS version changed from 2.4.0 to master

Salvatore Larosa wrote:

neither with the attached DB, | see with both browser and add button:

gid,arpa,id,_old,attivita

I am trying with SL 4.0.0 and SQLite 3.7.13

ok now | see: in the browser one must add the SL layer by browsing directly the SL file, not the connection.

#9 - 2014-10-26 08:38 AM - Salvatore Larosa
- Category changed from Browser to Data Provider/OGR
- Status changed from Open to Feedback

| see now, but it is an OGR provider issue and occurs only when a primary key was defined.
The FID Column has not fetched by ogr provider, but that might be considered as an expected behavior(?)

#10 - 2014-10-26 09:49 AM - Luca Lanteri

From the user point of view | think it can't be considered as an expected behavior primary because it's different from the "connection behaviour" and may
generate confusion.

#11 - 2014-10-26 11:00 AM - Salvatore Larosa

Yeah, | am in favour to the current behavior like the OGR provider does, | would like to extend it to the SL provider too.

Thoughts??

#12 - 2014-10-27 01:04 AM - Luca Lanteri

| think this isn't the right choice.

For a lot of reason | prefer to have the FID visible as occour for all other data source (e.g. for postgis layer).

#13 - 2014-10-29 08:34 AM - Jukka Rahkonen

If FIDs are visible can you still prevent users from editing them and making a disaster?

#14 - 2014-10-29 12:48 PM - Luca Lanteri

If you need you can de-check the editable option from the "Edit widget option". | thinks it's preferable to leave this choice to users. Moreover without a

visible FID it's not possible to uniquely identify features.

#15 - 2014-10-30 07:31 AM - Jukka Rahkonen

| must admit that | do not really use QGIS much. In WFS it is normal to hide FIDs from the users and it looks like QGIS WFS client is hiding them also. For

my mind FIDs are for the system but | understand that sometimes it it good to be able to see them. However, editing FIDs is usually an extremely bad idea.

For example if Spatialite happens to accept such edit it will invalidate spatial index and ruin foreign key relations. But perhaps | do not need to worry and

QGIS and database drivers + triggers in the databases can prevent all the damage.

#16 - 2015-01-31 10:16 AM - Luca Lanteri

A solution can be to set the FID field uneditable by default into the edit widget option and prompt users with a warning if they select the editable option.

#17 - 2015-12-20 09:10 AM - Giovanni Manghi

- Status changed from Feedback to Open

#18 - 2015-12-20 09:19 AM - Giovanni Manghi

see also #6226

#19 - 2016-10-07 05:51 AM - Even Rouault

- Target version set to Version 2.16

- Status changed from Open to Closed

- Resolution set to fixed/implemented
This issue was solved in QGIS 2.16.0 for a set of OGR drivers like spatialite, GPKG, etc...

Files

test.sqlite 4.1 MB 2014-10-25 Luca Lanteri
